Skip to main content

admin.apps.permissions.set method

The features within are only available to Slack workspaces on an Enterprise plan.

Don't have a paid plan? Join the Developer Program and provision a fully-featured sandbox for free.

Facts

DescriptionSet the permission type for who can access an app
Method Access
POST https://slack.com/api/admin.apps.permissions.set
Scopes
User token:
Content types
application/x-www-form-urlencoded
application/json

Arguments

Required arguments

tokenstringRequired

Authentication token bearing required scopes. Tokens should be passed as an HTTP Authorization header or alternatively, as a POST parameter.

Example: xxxx-xxxxxxxxx-xxxx
app_idstringRequired

Encoded ID of the app

Example: A0000000001
permission_typestringRequired

The type of permission that defines who can access the app

Acceptable values: everyone named_entities no_one

Optional arguments

user_idsarrayOptional

List of user IDs to allow for named_entities visibility

Example: ['U00000001', 'U00000002', 'U00000003']
usergroup_idsarrayOptional

List of encoded usergroup IDs

Example: S00000001,S00000002

Usage info

This method sets an app's permission_type value, which defines who in the org can access the app. When the permission_type field is set to named_entities, pass either or both user_ids and usergroup_ids to define the specific entities that are granted access.

To grant access for individual entities without changing the permission type, use the admin.apps.permissions.add method. To revoke access, use the admin.apps.permissions.remove method. To view the current permission type and its entities, use the admin.apps.permissions.list method.


Response

Errors

This table lists the expected errors that this method could return. However, other errors can be returned in the case where the service is down or other unexpected factors affect processing. Callers should always check the value of the ok parameter in the response.

Error
Description
access_denied

This actor does not have access to the permissions on this resource.

access_denied

Access to a resource specified in the request is denied.

accesslimited

Access to this method is limited on the current network

account_inactive

Authentication token is for a deleted user or workspace when using a bot token.

app_not_found

This app does not exist.

channel_ids_required

channel_ids is required when channel_restriction_mode is specific_channels or all_channels_except.

channel_not_found

One or more channel IDs are not valid.

deprecated_endpoint

The endpoint has been deprecated.

ekm_access_denied

Administrators have suspended the ability to post a message.

enterprise_is_restricted

The method cannot be called from an Enterprise.

fatal_error

The server could not complete your operation(s) without encountering a catastrophic error. It's possible some aspect of the operation succeeded before the error was raised.

internal_error

The server could not complete your operation(s) without encountering an error, likely due to a transient issue on our end. It's possible some aspect of the operation succeeded before the error was raised.

invalid_arg_name

The method was passed an argument whose name falls outside the bounds of accepted or expected values. This includes very long names and names with non-alphanumeric characters other than _. If you get this error, it is typically an indication that you have made a very malformed API call.

invalid_arguments

The method was called with invalid arguments.

invalid_array_arg

The method was passed an array as an argument. Please only input valid strings.

invalid_auth

Invalid authorization token

invalid_auth

Some aspect of authentication cannot be validated. Either the provided token is invalid or the request originates from an IP address disallowed from making the request.

invalid_channel_restriction_mode

The channel_restriction_mode value is not valid.

invalid_charset

The method was called via a POST request, but the charset specified in the Content-Type header was invalid. Valid charset names are: utf-8 iso-8859-1.

invalid_form_data

The method was called via a POST request with Content-Type application/x-www-form-urlencoded or multipart/form-data, but the form data was either missing or syntactically invalid.

invalid_permission_type

This app requires permission_type to be set as named_entities before adding users.

invalid_post_type

The method was called via a POST request, but the specified Content-Type was invalid. Valid types are: application/json application/x-www-form-urlencoded multipart/form-data text/plain.

method_deprecated

The method has been deprecated.

missing_post_type

The method was called via a POST request and included a data payload, but the request did not include a Content-Type header.

missing_scope

The token used is not granted the specific scope permissions required to complete this request.

named_entities_cannot_be_empty

Must pass at least one valid named entity.

no_permission

The workspace token used in this request does not have the permissions necessary to complete the request. Make sure your app is a member of the conversation it's attempting to post a message to.

no_valid_named_entities

None of the provided named entities were valid

not_allowed_token_type

The token type used in this request is not allowed.

not_an_enterprise

This feature is only available on Enterprise Grid plans.

not_authed

No authentication token provided.

org_login_required

The workspace is undergoing an enterprise migration and will not be available until migration is complete.

ratelimited

The request has been ratelimited. Refer to the Retry-After header for when to retry the request.

request_timeout

The method was called via a POST request, but the POST data was either missing or truncated.

service_unavailable

The service is temporarily unavailable

team_access_not_granted

The token used is not granted the specific workspace access required to complete this request.

team_added_to_org

The workspace associated with your request is currently undergoing migration to an Enterprise Organization. Web API and other platform operations will be intermittently unavailable until the transition is complete.

token_expired

Authentication token has expired

token_revoked

Authentication token is for a deleted user or workspace or the app has been removed when using a user token.

too_many_named_entities

Too many named_entities passed into the app permissions setting.

two_factor_setup_required

Two factor setup is required.

user_not_found

This actor does not have access to at least one valid named entity.

usergroup_not_found

The usergroup is not valid.